<?php

/*
|--------------------------------------------------------------------------
| Validation Language Lines
|--------------------------------------------------------------------------
|
| The following language lines contain the default error messages used by
| the validator class. Some of these rules have multiple versions such
| as the size rules. Feel free to tweak each of these messages here.
|
*/

return [
    'accepted'             => ':attribute må aksepteres.',
    'accepted_if'          => ':attribute må aksepteres når :other er :value.',
    'active_url'           => ':attribute er ikke en gyldig URL.',
    'after'                => ':attribute må være en dato etter :date.',
    'after_or_equal'       => ':attribute må være en dato etter eller lik :date.',
    'alpha'                => ':attribute må kun bestå av bokstaver.',
    'alpha_dash'           => ':attribute må kun bestå av bokstaver, tall og bindestreker.',
    'alpha_num'            => ':attribute må kun bestå av bokstaver og tall.',
    'array'                => ':attribute må være en matrise.',
    'before'               => ':attribute må være en dato før :date.',
    'before_or_equal'      => ':attribute må være en dato før eller lik :date.',
    'between'              => [
        'array'   => ':attribute må ha mellom :min - :max elementer.',
        'file'    => ':attribute må være mellom :min - :max kilobytes.',
        'numeric' => ':attribute må være mellom :min - :max.',
        'string'  => ':attribute må være mellom :min - :max tegn.',
    ],
    'boolean'              => ':attribute må være sann eller usann',
    'confirmed'            => ':attribute er ikke likt bekreftelsesfeltet.',
    'current_password'     => 'Oppgitt passord er feil.',
    'date'                 => ':attribute er ikke en gyldig dato.',
    'date_equals'          => ':attribute må være en dato lik :date.',
    'date_format'          => ':attribute samsvarer ikke med formatet :format.',
    'declined'             => ':attribute må avvises.',
    'declined_if'          => ':attribute må avvises når :other er :value.',
    'different'            => ':attribute og :other må være forskellige.',
    'digits'               => ':attribute må ha :digits siffer.',
    'digits_between'       => ':attribute må være mellom :min og :max siffer.',
    'dimensions'           => ':attribute har ugyldige bildedimensjoner.',
    'distinct'             => ':attribute har en duplisert verdi.',
    'email'                => ':attribute må være en gyldig e-postadresse.',
    'ends_with'            => ':attribute må ende med en av følgende: :values.',
    'enum'                 => 'Det valgte :attribute er ugyldig.',
    'exists'               => 'Det valgte :attribute er ugyldig.',
    'file'                 => ':attribute må være en fil.',
    'filled'               => ':attribute må fylles ut.',
    'gt'                   => [
        'array'   => ':attribute må ha flere enn :value elementer.',
        'file'    => ':attribute må være større enn :value kilobytes.',
        'numeric' => ':attribute må være større enn :value.',
        'string'  => ':attribute må være større enn :value tegn.',
    ],
    'gte'                  => [
        'array'   => ':attribute må ha :value elementer eller flere.',
        'file'    => ':attribute må være større enn eller lik :value kilobytes.',
        'numeric' => ':attribute må være større enn eller lik :value.',
        'string'  => ':attribute må være større enn eller lik :value tegn.',
    ],
    'image'                => ':attribute må være et bilde.',
    'in'                   => 'Det valgte :attribute er ugyldig.',
    'in_array'             => 'Det valgte :attribute eksisterer ikke i :other.',
    'integer'              => ':attribute må være et heltall.',
    'ip'                   => ':attribute må være en gyldig IP-adresse.',
    'ipv4'                 => ':attribute må være en gyldig IPv4-adresse.',
    'ipv6'                 => ':attribute må være en gyldig IPv6-addresse.',
    'json'                 => ':attribute må være på JSON-format.',
    'lt'                   => [
        'array'   => ':attribute må ha færre enn :value elementer.',
        'file'    => ':attribute må være mindre enn :value kilobytes.',
        'numeric' => ':attribute må være mindre enn :value.',
        'string'  => ':attribute må være kortere enn :value tegn.',
    ],
    'lte'                  => [
        'array'   => ':attribute må ikke ha flere enn :value elementer.',
        'file'    => ':attribute må være mindre enn eller lik :value kilobytes.',
        'numeric' => ':attribute må være mindre enn eller lik :value.',
        'string'  => ':attribute må være kortere enn eller lik :value tegn.',
    ],
    'mac_address'          => ':attribute må være en gyldig MAC-adresse.',
    'max'                  => [
        'array'   => ':attribute må ikke ha flere enn :max elementer.',
        'file'    => ':attribute må ikke være større enn :max kilobytes.',
        'numeric' => ':attribute må ikke være større enn :max.',
        'string'  => ':attribute må ikke være større enn :max tegn.',
    ],
    'mimes'                => ':attribute må være en fil av typen: :values.',
    'mimetypes'            => ':attribute må være en fil av typen: :values.',
    'min'                  => [
        'array'   => ':attribute må ha minst :min elementer.',
        'file'    => ':attribute må være minst :min kilobytes.',
        'numeric' => ':attribute må være minst :min.',
        'string'  => ':attribute må være minst :min tegn.',
    ],
    'multiple_of'          => ':attribute må være flere av :value',
    'not_in'               => 'Den valgte :attribute er ugyldig.',
    'not_regex'            => 'Formatet på :attribute er ugyldig.',
    'numeric'              => ':attribute må være et tall.',
    'password'             => 'Passordet er feil.',
    'present'              => ':attribute må eksistere.',
    'prohibited'           => ':attribute felt er forbudt.',
    'prohibited_if'        => ':attribute felt er forbudt når :other er :value.',
    'prohibited_unless'    => ':attribute felt er forbudt med mindre :other er i :values.',
    'prohibits'            => ':attribute forbyr :other å være til stede.',
    'regex'                => 'Formatet på :attribute er ugyldig.',
    'required'             => ':attribute må fylles ut.',
    'required_array_keys'  => ':attribute feltet må inneholde oppføringer for: :values.',
    'required_if'          => ':attribute må fylles ut når :other er :value.',
    'required_unless'      => ':attribute er påkrevd med mindre :other finnes blant verdiene :values.',
    'required_with'        => ':attribute må fylles ut når :values er utfylt.',
    'required_with_all'    => ':attribute er påkrevd når :values er oppgitt.',
    'required_without'     => ':attribute må fylles ut når :values ikke er utfylt.',
    'required_without_all' => ':attribute er påkrevd når ingen av :values er oppgitt.',
    'same'                 => ':attribute og :other må være like.',
    'size'                 => [
        'array'   => ':attribute må inneholde :size elementer.',
        'file'    => ':attribute må være :size kilobytes.',
        'numeric' => ':attribute må være :size.',
        'string'  => ':attribute må være :size tegn lang.',
    ],
    'starts_with'          => ':attribute må starte med en av følgende: :values.',
    'string'               => ':attribute må være en tekststreng.',
    'timezone'             => ':attribute må være en gyldig tidssone.',
    'unique'               => ':attribute er allerede i bruk.',
    'uploaded'             => ':attribute kunne ikke lastes opp.',
    'url'                  => 'Formatet på :attribute er ugyldig.',
    'uuid'                 => ':attribute må være en gyldig UUID.',
    'custom'               => [
        'attribute-name' => [
            'rule-name' => 'custom-message',
        ],
    ],
];
