{extends file="$layouts_admin"}

{block name="content"}
    <div class="row">


        <div class="col-lg-12 col-md-12 col-sm-12">
            <div class="panel">
                <div class="panel-hdr">
                    <h2>{$_L['Reports by Date']} </h2>

                </div>
                <div class="panel-container">
                    <div class="panel-content">
                        <div id="dpx" class="table-responsive"></div>
                        <div id="result">
                            <h2>{$_L['Total Income']}: {$config['currency_code']} {number_format($cr,2,$config['dec_point'],$config['thousands_sep'])}</h2>
                            <h2>{$_L['Total Expense']}: {$config['currency_code']} {number_format($dr,2,$config['dec_point'],$config['thousands_sep'])}</h2>

                            <hr>
                            <h4>{$_L['All Transactions at Date']}: <span id="tdate">{date( $config['df'], strtotime($mdate))}</span> </h4>
                            <hr>
                            <table class="table table-striped table-bordered table-responsive">

                                <th>{$_L['Account']}</th>
                                <th>{$_L['Type']}</th>
                                <th class="hidden-xs hidden-sm">{$_L['Category']}</th>
                                <th class="text-end">{$_L['Amount']}</th>
                                <th class="hidden-xs hidden-sm hidden-md">{$_L['Payer']}</th>
                                <th class="hidden-xs hidden-sm hidden-md">{$_L['Payee']}</th>
                                <th class="hidden-xs hidden-sm hidden-md">{$_L['Method']}</th>
                                <th class="hidden-xs hidden-sm hidden-md">{$_L['Ref']}</th>
                                <th>{$_L['Description']}</th>
                                <th class="text-end">{$_L['Dr']}</th>
                                <th class="text-end">{$_L['Cr']}</th>
                                {*                            <th class="text-end">{$_L['Balance']}</th>*}

                                {foreach $d as $ds}
                                    <tr>

                                        <td>{$ds['account']}</td>
                                        {*<td>{$ds['type']}</td>*}
                                        <td>{ib_lan_get_line($ds['type'])}</td>
                                        <td>{if $ds['category'] == 'Uncategorized'}{$_L['Uncategorized']} {else} {$ds['category']} {/if}</td>
                                        <td class="text-end">{$config['currency_code']} {number_format($ds['amount'],2,$config['dec_point'],$config['thousands_sep'])}</td>
                                        <td class="hidden-xs hidden-sm hidden-md">{$ds['payer']}</td>
                                        <td class="hidden-xs hidden-sm hidden-md">{$ds['payee']}</td>
                                        <td class="hidden-xs hidden-sm hidden-md">{$ds['method']}</td>
                                        <td class="hidden-xs hidden-sm hidden-md">{$ds['ref']}</td>
                                        <td>{$ds['description']}</td>
                                        <td class="text-end">{$config['currency_code']} {number_format($ds['dr'],2,$config['dec_point'],$config['thousands_sep'])}</td>
                                        <td class="text-end">{$config['currency_code']} {number_format($ds['cr'],2,$config['dec_point'],$config['thousands_sep'])}</td>
                                        {*                                    <td class="text-end"><span {if $ds['bal'] < 0}class="text-red"{/if}>{$config['currency_code']} {number_format($ds['bal'],2,$config['dec_point'],$config['thousands_sep'])}</span></td>*}

                                    </tr>
                                {/foreach}


                                <tfoot>
                                <tr>
                                    <th colspan="9" style="text-align:right">{$_L['Total']}:</th>
                                    <th>{ib_money_format($dr,$config)}</th>
                                    <th colspan="2">{ib_money_format($cr,$config)}</th>

                                </tr>
                                </tfoot>

                            </table>
                        </div>
                    </div>






                </div>
            </div>
        </div>



        <!-- Widget-2 end-->
    </div>



{/block}

{block name="script"}
    <script>
        $(function () {

            let $dpx = $('#dpx');

            $dpx.datepaginator(
                {

                    selectedDate: '{date('Y-m-d')}',
                    selectedDateFormat:  'YYYY-MM-DD',
                    textSelected:  "dddd<br/>YYYY-MM-DD"
                }
            );
            $dpx.on('selectedDateChanged', function(event, date) {
                $( "#result" ).html( "<h3>Loading.....</h3>" );
                $.get( base_url + "ajax.date-summary/" + date, function( data ) {
                    $( "#result" ).html( data );
                });
            });

        });
    </script>
{/block}
