<?php
require 'apps/razorpay/vendor/autoload.php';
$has_login_token = Contact::hasLoginToken();

$today = date('Y-m-d H:i:s');

$xfooter = Asset::js(array('numeric'));

$id  = $routes['2'];

$d = ORM::for_table('sys_invoices')->find_one($id);
if($d){
    $token = $routes['3'];
    $token = str_replace('token_','',$token);
    $vtoken = $d['vtoken'];
    if($token != $vtoken){
        echo 'Sorry Token does not match!';
        exit;
    }


    $items = ORM::for_table('sys_invoiceitems')->where('invoiceid',$id)->order_by_asc('id')->find_many();
    $ui->assign('items',$items);
    //find related transactions
    $trs_c = ORM::for_table('sys_transactions')->where('iid', $id)->count();

    $trs = ORM::for_table('sys_transactions')->where('iid', $id)->order_by_desc('id')->find_many();
    $ui->assign('trs', $trs);
    $ui->assign('trs_c', $trs_c);
//find the user
    $a = ORM::for_table('crm_accounts')->find_one($d['userid']);
    $ui->assign('a',$a);
    $ui->assign('d',$d);

    $i_credit = $d['credit'];
    $i_due = '0.00';
    $i_total = $d['total'];
    if($d['credit'] != '0.00'){
        $i_due = $i_total - $i_credit;
    }
    else{
        $i_due =  $d['total'];
    }




    $ui->assign('i_due', $i_due);

//            $pgs = ORM::for_table('sys_pg')->where('status','Active')->order_by_asc('sorder')->find_many();
//
//            $ui->assign('pgs',$pgs);
    $cf = ORM::for_table('crm_customfields')->where('showinvoice','Yes')->order_by_asc('id')->find_many();
    $ui->assign('cf',$cf);

    $x_html = '';

    Event::trigger('view_invoice');

    $ui->assign('xfooter', $xfooter);



    $ui->assign('x_html',$x_html);

    $inv_files = Invoice::files($id);

    $inv_files_c = count($inv_files);

    $ui->assign('inv_files_c',$inv_files_c);

    $ui->assign('inv_files',$inv_files);

    //

    if(!isset($_SESSION['uid'])){

        $ip = get_client_ip();
        // log invoice access log

        $country = $_L['Unknown'];
        $city = $_L['Unknown'];
        $lat = '';
        $lon = '';

        if(isset($_SERVER['HTTP_REFERER'])){
            $referer = $_SERVER['HTTP_REFERER'];
        }
        else{
            $referer = '';
        }

        if(isset($_SERVER['HTTP_USER_AGENT'])){
            $browser = $_SERVER['HTTP_USER_AGENT'];
        }
        else{
            $browser = '';
        }

        if($config['maxmind_installed'] == 1){

            $l_data = Ip2Location::getDetails($ip);

            $country = $l_data['country'];
            $city = $l_data['city'];
            $lat = $l_data['lat'];
            $lon = $l_data['lon'];


        }

        $ial = ORM::for_table('ib_invoice_access_log')->create();
        $ial->iid = $id;
        $ial->ip = $ip;
        $ial->browser = $browser;
        $ial->referer = $referer;
        $ial->country = $country;
        $ial->city = $city;
        $ial->viewed_at = $today;
        $ial->customer = $d->account;
        $ial->save();



    }


    //


    if($a->cid != '' || $a->cid != 0){
        $company = Company::find($a->cid);
    }
    else{
        $company = false;
    }

    // find the quote

    $quote = false;

    if($d->quote_id != '0'){
        $quote = ORM::for_table('sys_quotes')->find_one($d->quote_id);
    }

    $plugin_extra_js = '';



    $currencies_all = Currency::getAllCurrencies();

    if(isset($currencies_all[$d->currency_iso_code]))
    {
        $data_a_sign = $currencies_all[$d->currency_iso_code]['symbol'];
        $data_a_sep = $currencies_all[$d->currency_iso_code]['thousands_separator'];
        $data_a_dec = $currencies_all[$d->currency_iso_code]['decimal_mark'];

        if($currencies_all[$d->currency_iso_code] == true)
        {
            $data_p_sign = 'p';
        }
        else{
            $data_p_sign = 's';
        }
    }
    else{
        $data_a_sign = $config['currency_code'];
        $data_a_sep = $config['thousands_sep'];
        $data_a_dec = $config['dec_point'];
        $data_p_sign = $config['currency_symbol_position'];
    }


    $payment_gateways = PaymentGateway::where('status','Active')
        ->orderBy('sorder','asc')
        ->get();

    $payment_gateways_by_processor = $payment_gateways->keyBy('processor')->toArray();

    $g = PaymentGateway::where('processor','razorpay')->first();

    $pref = SharedPreference::where('relation_type','razorpay_payment')
        ->where('relation_id',$d->id)
        ->where('key','order_id')
        ->first();



    $amount = $i_due*100;



    if($pref)
    {
        $order_id = $pref->value;
    }
    else{


        try{

            $api = new \Razorpay\Api\Api($g->value, $g->c1);
            $order  = $api->order->create(array('receipt' => $d->id, 'amount' => $amount, 'currency' => $d->currency_iso_code));
        } catch (\Exception $e)
        {
            dd($e->getMessage());
        }

        $order_id = $order['id'];

        $pref = setSharedPreferences('razorpay_payment',$d->id,'order_id',$order_id);
    }


    view('content_only',[
        '_include' => 'invoice',
        'company' => $company,
        'quote' => $quote,
        'plugin_extra_js' => $plugin_extra_js,
        'data_a_sign' => $data_a_sign,
        'data_a_sep' => $data_a_sep,
        'data_a_dec' => $data_a_dec,
        'data_p_sign' => $data_p_sign,
        'payment_gateways' => $payment_gateways,
        'payment_gateways_by_processor' => $payment_gateways_by_processor,
        'has_login_token' => $has_login_token,
        'g' => $g,
        'order_id' => $order_id,
        'amount' => $amount,
    ]);

}
else{
    r2(U . 'customers/list', 'e', $_L['Account_Not_Found']);
}