<?php
require 'apps/razorpay/vendor/autoload.php';
$ui->assign('selected_navigation', 'notes');
$ui->assign('_title', 'Notes' . ' - ' . $config['CompanyName']);
$ui->assign('_st', 'Notes');
$action = $routes[2];

switch ($action) {
    case 'make':
        // Find Invoice

        $id = $routes[3];
        $d = ORM::for_table('sys_invoices')->find_one($id);
        if (!$d) {
            exit('Invoice Not Found');
        }

        $token = $routes[4];
        $token = str_replace('token_', '', $token);
        $vtoken = $d['vtoken'];
        if ($token != $vtoken) {
            echo 'Sorry Token does not match!';
            exit();
        }

        $i_credit = $d['credit'];
        $i_due = '0.00';
        $i_total = $d['total'];

        $amount = $i_total - $i_credit;
        $invoiceid = $d['id'];
        $vtoken = $d['vtoken'];
        $ptoken = $d['ptoken'];

        //get user details

        $u = ORM::for_table('crm_accounts')->find_one($d['userid']);

        // find pag

        $g = PaymentGateway::where('processor', 'razorpay')->first();

        $amount = $amount * 100;

        $pref = getSharedPreferences('razorpay_payment', $d->id, 'link');

        if ($pref) {
            header('location: ' . $pref->value);
        } else {
            try {
                $api = new \Razorpay\Api\Api($g->value, $g->c1);

                $link = $api->invoice->create([
                    'type' => 'link',
                    'amount' => $amount,
                    'callback_url' =>
                        U . "client/ipay_success/$id/token_$ptoken/",
                    'callback_method' => 'get',
                    // 'reference_id' => $id,
                    'currency' => $d->currency_iso_code ?? 'INR',
                    'description' =>
                        'Invoice #' . $d->invoicenum . $d->cn ?? $d->id,
                    'customer' => [
                        'email' => $u['email'],
                    ],
                ]);

                $pref = setSharedPreferences(
                    'razorpay_payment',
                    $d->id,
                    'link',
                    $link->short_url
                );

                header('location: ' . $link->short_url);
            } catch (\Exception $e) {
                dd($e->getMessage());
            }
        }

        break;

    case 'submitted':
        $inv_id = route(3);
        $token = route(4);

        r2(
            U . 'client/iview/' . $inv_id . '/' . $token,
            'e',
            'Payment Success.'
        );

        break;

    case 'failed':
        // redirect to original page

        $inv_id = route(3);
        $token = route(4);

        r2(U . 'client/iview/' . $inv_id . '/' . $token, 'e', 'Payment Failed');

        break;

    default:
        echo 'action not defined';
}
